-- Put your target database name at the next line
USE `OData_20160204`;

CREATE TABLE IF NOT EXISTS `RWADOData_User` (
  `UserID` bigint NOT NULL AUTO_INCREMENT,
  `Login` varchar(50) NOT NULL,
  `Email` varchar(50) NULL,
  `LastName` varchar(255) NULL,
  `FirstName` varchar(255) NULL,
  `MiddleInitial` varchar(255) NULL,
  `PhoneNumber` varchar(20) NULL,
  `Password` varchar(255) NOT NULL,
  `PasswordSalt` varchar(255) NOT NULL,
  PRIMARY KEY (`UserID`),
  UNIQUE INDEX `UserID_UNIQUE` (`UserID` ASC))
ENGINE = InnoDB;


CREATE TABLE IF NOT EXISTS `RWADOData_Permission` (
  `PermissionID` int NOT NULL AUTO_INCREMENT,
  `TableName` varchar(255) NOT NULL,
  `ActionName` varchar(255) NOT NULL,  
  PRIMARY KEY (`PermissionID`),
  UNIQUE INDEX `PermissionID_UNIQUE` (`PermissionID` ASC))
ENGINE = InnoDB;


CREATE TABLE IF NOT EXISTS `RWADOData_Role` (
  `RoleID` int NOT NULL AUTO_INCREMENT,
  `Name` varchar(255) NOT NULL,
  PRIMARY KEY (`RoleID`),
  UNIQUE INDEX `RoleID_UNIQUE` (`RoleID` ASC))
ENGINE = InnoDB;


CREATE TABLE IF NOT EXISTS `RWADOData_PermissionRole` (
  `PermissionRoleID` int NOT NULL AUTO_INCREMENT,
  `RoleID` int NOT NULL,
  `PermissionID` int NOT NULL,
  `IsEnabled` bit NOT NULL,
  PRIMARY KEY (`PermissionRoleID`),
  KEY `RoleID` (`RoleID`),
  CONSTRAINT `Role_RolePermissions` 
	FOREIGN KEY (`RoleID`) REFERENCES `RWADOData_Role` (`RoleID`) ON DELETE CASCADE ON UPDATE NO ACTION,
  KEY `PermissionID` (`PermissionID`),
  CONSTRAINT `Permissions_RolesPermisssions` 
	FOREIGN KEY (`PermissionID`) REFERENCES `RWADOData_Permission` (`PermissionID`) ON DELETE CASCADE ON UPDATE NO ACTION,
  UNIQUE INDEX `PermissionRoleID_UNIQUE` (`PermissionRoleID` ASC))
ENGINE = InnoDB;


CREATE TABLE IF NOT EXISTS `RWADOData_UserRole` (
  `UserRoleID` int NOT NULL AUTO_INCREMENT,
  `UserID` bigint NOT NULL,
  `RoleID` int NOT NULL,
  PRIMARY KEY (`UserRoleID`),
  KEY `UserID` (`UserID`),
  CONSTRAINT `User_Roles` 
	FOREIGN KEY (`UserID`) REFERENCES `RWADOData_User` (`UserID`) ON DELETE CASCADE ON UPDATE NO ACTION,
  KEY `RoleID` (`RoleID`),
  CONSTRAINT `Role_Users` 
	FOREIGN KEY (`RoleID`) REFERENCES `RWADOData_Role` (`RoleID`) ON DELETE CASCADE ON UPDATE NO ACTION,  
  UNIQUE INDEX `UserRoleID_UNIQUE` (`UserRoleID` ASC))
ENGINE = InnoDB;